  // save context and get return address

  // Disable interrupts
  OldGIE := GIE_Bit;  
  GIE_Bit := 0;  

  // Save Context
  asm
    // Save Return address (can not be done in a subroutine)
    MOVFF TOSL,  CRTOS_TmpRegs + 31
    MOVFF TOSH,  CRTOS_TmpRegs + 32
    MOVFF TOSU,  CRTOS_TmpRegs + 33
  end;
  Save_Context; // Save all others and copy to the task
  
  // Enable Interrupts
  GIE_Bit := OldGIE; 