  // select next Ready task

  repeat
    Select_Next_Task;
  until CurrentTask <> OS_NO_TASK; 

  // disable interrupts
  OldGIE := GIE_bit;  
  GIE_bit := 0;

  TaskData[CurrentTask]._State := st_RUNNING; // this task is running now 

  // Restore context
  Restore_Context; // recall context from the Task to TmpRegs and restore to PIC registers except the return address
  asm
    // restore the Return address (can not be done in a subroutine)
    MOVFF CRTOS_TmpRegs + 31, TOSL
    MOVFF CRTOS_TmpRegs + 32, TOSH
    MOVFF CRTOS_TmpRegs + 33, TOSU
  end;

  // enable interrupts
  GIE_bit := OldGIE; 